"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerCaseLevelQuestions(ProtocolElement):
    """
    The questions for the cancer program exit questionnaire at case level
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "actionableVariants",
        "mdt1_time",
        "primary_authorisation_time",
        "primary_reporting_time",
        "report_distribution_time",
        "reviewedInMdtWga",
        "total_review_time",
        "total_time",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "actionableVariants": reports_6_0_1.CancerActionableVariants,
            "reviewedInMdtWga": reports_6_0_1.ReviewedParts,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_2 import reports as reports_6_0_1

        return {
            "org.gel.models.report.avro.CancerActionableVariants": reports_6_0_1.CancerActionableVariants,
            "org.gel.models.report.avro.ReviewedParts": reports_6_0_1.ReviewedParts,
            "org.gel.models.report.avro.CancerCaseLevelQuestions": reports_6_0_1.CancerCaseLevelQuestions,
        }

    __slots__ = [
        "actionableVariants",
        "mdt1_time",
        "primary_authorisation_time",
        "primary_reporting_time",
        "report_distribution_time",
        "reviewedInMdtWga",
        "total_review_time",
        "total_time",
        "analytical_validation_time",
        "mdt2_time",
        "validation_assay_time",
        "wet_validation_time",
    ]

    def __init__(
        self,
        actionableVariants,
        mdt1_time,
        primary_authorisation_time,
        primary_reporting_time,
        report_distribution_time,
        reviewedInMdtWga,
        total_review_time,
        total_time,
        analytical_validation_time=None,
        mdt2_time=None,
        validation_assay_time=None,
        wet_validation_time=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_0_1.CancerCaseLevelQuestions model.

        :param actionableVariants:
            Were potentially actionable variants detected?
        :type actionableVariants: CancerActionableVariants
        :param mdt1_time:
            Time taken to discuss case at MDT (hours).
        :type mdt1_time: double
        :param primary_authorisation_time:
            Report Authorisation. Time taken to check and authorise report
            (hours).
        :type primary_authorisation_time: double
        :param primary_reporting_time:
            Primary Reporting. Time taken to complete primary reporting stage
            (hours).
        :type primary_reporting_time: double
        :param report_distribution_time:
            Report Distribution.         Please enter, where possible/accessible
            how long it takes for the result to be conveyed to the
            patient.         E.g. via letter from the clinician
            (days).
        :type report_distribution_time: double
        :param reviewedInMdtWga:
            Which parts of the WGA were reviewed?
        :type reviewedInMdtWga: ReviewedParts
        :param total_review_time:
            Total time taken to review/collate evidence for variants (hours).
            Include all literature review time, consultation with
            relevant experts etc.
        :type total_review_time: double
        :param total_time:
            Total time from result to report.         The total time taken from
            when the analysis of the WGS results started  to a report
            being received         by the patient include any
            'waiting' time (days).
        :type total_time: double
        :param analytical_validation_time:
            Analytical Laboratory Validation. Total time for analysis of
            validation results for all variants (hours).
        :type analytical_validation_time: None | double
        :param mdt2_time:
            If the case is discussed at a 2nd MDT please enter time here (hours).
        :type mdt2_time: None | double
        :param validation_assay_time:
            Total time to design ALL validation assay(s) for case (hours).
            Only applicable if it is necessary to design a new assay
            to validate the variant.
        :type validation_assay_time: None | double
        :param wet_validation_time:
            Technical Laboratory Validation. Total time for validation test wet
            work for all variants (hours).
        :type wet_validation_time: None | double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.0.1"
